package com.softgraf.model.dao;

import java.util.List;

/*
 * DAO Genérico (Data Access Object -> objeto de acesso à dados)
 * DAO é um padrão de projeto, não é uma tecnologia java
 * DAO é uma interface de operação CURD
 * Pode ser uma interface ou uma classe abstrata
 */

public interface AbstractGenericDAO<T> {

	// todo método de interface, por padrão, é abstract public
	boolean inserir(T objeto);
	
	boolean remover(int id);
	
	boolean atualizar(int id, T objeto);
	
	List<T> listarPorId(int idInicial, int quant);
	
	T buscar(int id);
	
	int contar();
}
